//+------------------------------------------------------------------+
//|                                                   FISHTSS_EA.MQ4 |
//|                                                      VERSION 2.0 |
//|                                            Copyright  2007, JAM |
//|                                                THE SIMPLE SYSTEM |
//|                            CORRECTED VERSION BY JAM 14 JUNE 2007 |
//|                                              ALL RIGHTS RESERVED |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, JAM"
#property link "FISHTSS_EA by JAM"

//---- input parameters
extern double Lots         = 0.5;
extern double TakeProfit   = 90;
extern double StopLoss     = 25;
extern double TrailingStop = 60;
extern int maperiod        = 14;
extern double buythr       = 8;
extern double selthr       = 8;


double Points;
//+------------------------------------------------------------------+
//| expert initialization function |
//+------------------------------------------------------------------+
int init()
{
   Points = MarketInfo(Symbol(), MODE_POINT);
//----
   return(0);
}

//+------------------------------------------------------------------+
//|        Expert Deinitialization                                   |
//+------------------------------------------------------------------+
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//| expert start function |
//+------------------------------------------------------------------+

int start()
{
   int cnt = 0, total, SymOrdTotal = 0;
   int i1, pp, shift;
   double Tv[2][500] ;
   double BuySig=0, SellSig=0, val3;

   if(AccountFreeMargin() < (100*Lots))
   {
      Print("ERROR:  Insufficient funds in Account!");
      return(0);
   }

   if(Bars < 100)
   {
       Print("ERROR: Number of Bars Less Than 100!");
       return(0); 
   }

   if(TakeProfit < 10)
   {
       Print("ERROR: TakeProfit Less Than 10!");
       return(0); 
   }
//=============================================================================

   double ax1,ax0,slopebuy,slopesel;
   
   ax0=iMA(NULL,0,maperiod,0,MODE_LWMA,PRICE_CLOSE,0);
   ax1=iMA(NULL,0,maperiod,0,MODE_LWMA,PRICE_CLOSE,1);
   
   
   slopebuy=(ax0-ax1)/Point; slopesel=(ax0-ax1)/Point;
   
   if(slopebuy>=buythr) BuySig=1; else BuySig=0;
   if(slopesel<=-selthr) SellSig=1; else SellSig=0;
   
         
   //SellSig=iCustom(NULL,0,"TSSv1_2",4,1.5,0,0);
   //BuySig =iCustom(NULL,0,"TSSv1_2",4,1.5,1,0);
   
//==============================================================================

  total = OrdersTotal();
   
  // CLOSE ANY OPEN ORDERS AGAINST THIS PAIR
  // IF NEW BUY/SELL SIGNAL TRIGGERED.  ONLY
  // TRADE IN OPPOSING SIGNAL DIRECTION IS CLOSED.
  for(cnt = 0; cnt < total; cnt++)
  {
       OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
       if(OrderSymbol()==Symbol())  
       {
          // CLOSE ANY BUY ORDERS IF SELL SIGNAL TRIGGERED. 
          if(OrderType() == OP_BUY) 
          {
               if(SellSig != 0)
               {
                   OrderClose(OrderTicket(), OrderLots(), Bid, 3, Violet); 
               }
               if(TrailingStop > 0) 
               { 
                   if(Bid - OrderOpenPrice() > Points*TrailingStop)
                   {
                       if(OrderStopLoss() < Bid - Points*TrailingStop)
                       {
                           OrderModify(OrderTicket(), OrderOpenPrice(), 
                                       Bid - Points*TrailingStop, 
                                       OrderTakeProfit(), 0, Red);
                       }
                   }
               }
          }
           
          // CLOSE ANY SELL ORDERS IF BUY SIGNAL TRIGGERED. 
          if(OrderType() == OP_SELL)  
          {
               if(BuySig != 0)
               {
                   OrderClose(OrderTicket(), OrderLots(), Ask, 3, Violet); 
                }
               
               if(TrailingStop > 0) 
               { 
                   if((OrderOpenPrice() - Ask) > (Points*TrailingStop))
                   {
                       if(OrderStopLoss() == 0.0 || OrderStopLoss() > 
                          (Ask + Points*TrailingStop))
                       {
                           OrderModify(OrderTicket(), OrderOpenPrice(), 
                                       Ask + Points*TrailingStop, 
                                       OrderTakeProfit(), 0, Red);
                       }
                   }
               }
          }
       } 
  }
  
  total = OrdersTotal();

  // CHECK FOR ANY OPEN ORDERS AGAINST THIS PAIR.
  for(cnt = 0; cnt < total; cnt++)
  {
       OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
       if(OrderSymbol()==Symbol()){ SymOrdTotal++; }  
  }
  
  // EXECUTE NEW TRADE IF NO OPEN ORDERS FOR THIS PAIR.   
  if ( SymOrdTotal==0 )
  {
       // BUY SIGNAL TRIGGRED - OPEN BUY ORDER.
       if( BuySig != 0 )
         {
           OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, Ask-StopLoss*Point,
           Ask + TakeProfit*Points,"BARS EAV2", 15555, 0, Aqua); 
           if(GetLastError() == 0)
               Print("Buy Order Opened @ ", OrderOpenPrice());
           return(0); 
         }

       // SELL SIGNAL TRIGGERED - OPEN SELL ORDER.
       if( SellSig != 0 )
         {
           OrderSend(Symbol(), OP_SELL, Lots, Bid, 3, Bid+StopLoss*Point,
           Bid - TakeProfit*Points,"BARS EAV2", 15555, 0, Red); 
           if(GetLastError() == 0)
               Print("Sell Order Opened: ", OrderOpenPrice());
           return(0); 
         }
  }
   
  return(0);
}

//+------------------------------------------------------------------+

